Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.controls
Class JetProperty

    java.lang.Object
      jet.controls.JetProperty

All Implemented Interfaces:
  jet.convert.PropInfo, jet.util.Propertiable

Direct Known Subclasses:
  JetBoolean, JetColor, JetCommand, JetEnumeration, JetNumber, JetReference, JetString, JetVector

    public abstract class JetProperty

extends java.lang.Object
implements jet.util.Propertiable, jet.convert.PropInfo

The base class of all the property

property includes four parts so far: owner, name, value status, edit attribute.

- edit attribute is only for the Designer UI such as editor, editor status, value change listener, property choice...
- value status, in general, can be divided into normal value, default value, ChangeBy value, Auto value. The priority in use is Auto value > ChangeBy value > normal value > default value
  Auto value, a flag specified actual value must be calculated by 'algorithm in Feature Specification document', always exclusive of other
  ChangeBy value, the description of 'changed by' and actual value must be calculated based on runtime context contains 'runtime change by','another object', 'conditional formatting'(since V9), 'on the fly formula'(since V9). The priority in use is 'runtime change by' > 'conditional formatting' > 'on the fly formula' > 'another object' * 'runtime change by' : it is a Non-persistent description, the persistent processes should ignore it

Additional:

1. It contains a attribute for 'export to RST': can export to rst?
2. It contains an inner type for 'export', such as `Propertiable.IGNORED`,`Propertiable.BOOLEAN`....(detail please refer to `Propertiable`)
3. In most running, 'ChagneBy value' can not used to calculate directly, so attribute runtime change by had been appended(since V10).

Field Summary
`static int` | `CHART_BACKGROUND_EDITOR` Editor: CHART_BACKGROUND_EDITOR;ONLY For Designer UI
`static int` | `CHART_FILLPATTERN_EDITOR` Editor: CHART_FILLPATTERN_EDITOR;ONLY For Designer UI
`static int` | `CHART_FILTER_EDITOR` Editor: CHART_FILTER_EDITOR; ONLY For Designer UI
`static int` | `CHART_FILTER_EDITOR_NO_DATE` Editor: CHART_FILTER_EDITOR_NO_DATE; ONLY For Designer UI
`static int` | `CHART_ICON_STYLE` Editor: CHART_ICON_STYLE;ONLY For Designer UI
`static int` | `CHART_PATTERN_LIST_EDITOR` Editor: CHART_PATTERN_LIST_EDITOR;ONLY For Designer UI
`static int` | `CHART_PENSTYLE_EDITOR` Editor: CHART_PENSTYLE_EDITOR;ONLY For Designer UI
`static int` | `CHART_TEXTSTYLE_EDITOR` Editor: CHART_TEXTSTYLE_EDITOR;ONLY For Designer UI
`static int` | `CHOICE_EDITOR` Editor: CHOICE_EDITOR;ONLY For Designer UI
`static int` | `COLOR_EDITOR` Editor: COLOR_EDITOR;ONLY For Designer UI
`static int` | `COMBO_EDITOR` Editor: COMBO_EDITOR;ONLY For Designer UI
`static int` | `COMMAND_EDITOR` Editor: COMMAND_EDITOR;ONLY For Designer UI
`static int` | `CONTROL_SELECT_ITEMS` Editor: CONTROL_SELECT_ITEMS; ONLY For Designer UI
`static int` | `DATASOURCE_EDITOR` Editor: DATASOURCE_EDITOR; ONLY For Designer UI
`static int` | `DBCOL_EDITOR` Editor: DBCOL_EDITOR;ONLY For Designer UI
`static int` | `DETAIL_REPORT_EDITOR` Editor: DETAIL_REPORT_EDITOR;ONLY For Designer UI
`static int` | `EDIT_FORBIDDEN` editor status: EDIT_FORBIDDEN;, ONLY For Designer UI
`static int` | `EDIT_FORBIDDEN_INIT` editor status: EDIT_FORBIDDEN_INIT; ONLY For Designer UI
`static int` | `EDITABLE_ALLTIME` editor status: EDITABLE_ALLTIME; ONLY For Designer UI
`static int` | `INTERNAL` editor status: INTERNAL; ONLY For Designer UI
`static int` | `LINK_EDITOR` Editor: LINK_EDITOR;ONLY For Designer UI
`static int` | `MULSEL_EDITOR` Editor: MULSEL_EDITOR;ONLY For Designer UI
`static int` | `PARAMCOL_EDITOR` Editor: PARAMCOL_EDITOR;ONLY For Designer UI
`static int` | `QUERY_EDITOR` Editor: QUERY_EDITOR;ONLY For Designer UI
`static int` | `RECORDDB_EDITOR` Editor: RECORDDB_EDITOR;ONLY For Designer UI
`static int` | `SECURITY_EDITOR` Editor: SECURITY_EDITOR;ONLY For Designer UI
`static int` | `TEXT_EDITOR` Editor: TEXT_EDITOR;ONLY For Designer UI

Fields inherited from interface jet.util.Propertiable
`BIGSTRING, BOOLEAN, CHG_FMTTINGBLNAME, CHG_FMTTINGFORMULA, CHG_OTHER, COLOR, COMPFML_RESOURCE, CUSTOMER, CUSTOMERLINK, DELIM, DELIMCHAR, DOUBLE, ENUMERATION, IGNORED, IMAGE, IMGVECTOR, MAPPINGTBL, NORMAL_RESOURCE, NUMBER, REFERENCE, STRING, SUB1_DELIM, UNIT, VAL_NORMALLENGTH, VAL_NORMALSTART, VECTOR`

Constructor Summary
`JetProperty()`
`JetProperty(jet.controls.JetObject parent, java.lang.String name)`

Method Summary
`boolean` | `canChangeByBL()` Can the property be changed by 'on the fly formula'
`boolean` | `canChangeByFmtt()` Can the property be changed by 'conditional formatting'
`boolean` | `canChangeByOthers()` Can the property be changed by 'another object'
`void` | `enableAllChangeBys(boolean bEnable)` Batch set can the property be changed by ChangeBy value
`jet.controls.JetChangeBy` | `getChangeBy()` Deprecated.
`java.lang.Object` | `getChangeByBL()` Effective if `isCurrentAutoValue()` is false AND `isChangeByBL()` is true.
`java.lang.String` | `getChangeByBLName()` Deprecated.
`short` | `getChangeByBLType()` Effective if `isCurrentAutoValue()` is false AND `isChangeByBL()` is true Returns the resource type of 'another object': `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource) or `Propertiable.COMPFML_RESOURCE`(Component Level resource)
`java.lang.Object` | `getChangeByFmtt()` Effective if `isCurrentAutoValue()` is false AND `isChagneByFmtt()` is true
`java.lang.String` | `getChangeByFmttName()` Deprecated.
`java.lang.Object` | `getChangeByObject()` Effective if `isCurrentAutoValue()` is false AND `isChangeByOther()` is true.
`java.lang.String` | `getChangeByObjectName()` Deprecated.
`short` | `getChangeByOtherType()` Effective if `isCurrentAutoValue()` is false AND `isChangeByOther()` is true Returns the resource type of 'another object': `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource) or `Propertiable.COMPFML_RESOURCE`(Component Level resource)
`java.lang.Object` | `getCurrentChangedBy(boolean isIncludeRTChgBy)`
`jet.icontrols.PropValueInfo` | `getCurrentValue()` Note to developer0:Now, it only can be used in Property Edit Actions and simple value parser.
`jet.icontrols.PropValueInfo` | `getCurrentValue(boolean isFmttContext)` Note to developer0:Now, it only can be used in Property Edit Actions and simple value parser.
`int` | `getEditFlag()` Only for Designer UI.
`int` | `getEditorType()` Only For Designer UI.
`java.lang.String` | `getInspValue()` Effective if `isCurrentAutoValue()` is false.
`java.lang.String` | `getInspValue(int unit, int fraction)` Deprecated.
`int[]` | `getMatchingSqlType()` Now, this API only for designer UI : get Matching SQL Type of this property Usage in UI : list all the (normal-)formula whose data-type in returned array
`java.lang.String` | `getName()`
`java.lang.Object` | `getNormalObject()` According to the following priority return : normal value > default value Effective if `isCurrentAutoValue()` is false
`java.lang.Object` | `getObject()` According to the following priority return : 'another object' > normal value > default value Notice1: returned 'another object' is the description of 'changed by' Notice2: Effective if `isCurrentAutoValue()` is false
`jet.controls.JetObject` | `getParent()`
`java.util.Vector<?>` | `getPropertyChoice()` Only For Designer UI
`int` | `getPropType()`
`java.lang.Object` | `getRuntimeChangeBy()`
`java.lang.Object` | `getUnifiedObject()` Effective if `isCurrentAutoValue()` is false According to the following priority return : ChangeBy value > normal value > default value Notice: returned ChangeBy value is the description of 'changed by'
`java.lang.Object` | `getValue()` Effective if `isCurrentAutoValue()` is false
`boolean` | `isChagneByFmtt()` Effective if `isCurrentAutoValue()` is false
`boolean` | `isChangeByBL()` Effective if `isCurrentAutoValue()` is false
`boolean` | `isChangeByOther()` Effective if `isCurrentAutoValue()` is false
`boolean` | `isCurrentAutoValue()` Returns current is Auto value flag or not; always return false if did not enable Auto value
`boolean` | `isCurrentChangedBy(boolean isIncludeRTChgBy)`
`boolean` | `isEnableAutoValue()` Returns is enable or disable Auto value, default return false
`boolean` | `isNull()` Is set normal value? Notice: This function has disabled from V8.
`boolean` | `isSetAnyChangeBy()` return true if ChangeBy Value: conditional formatting or ChangeBy Value: on the fly formula or ChangeBy Value: another object is set
`boolean` | `isSetRuntimeChgBy()`
`boolean` | `isTransient()` Gets attribute for 'export to RST'.
`void` | `loadFullChangeBy(java.lang.String changeBy)` ONLY FOR LOAD CHANGE BY STRING
`void` | `propertyChanged()` Force refresh the property information that managed in/by owner. Note to developer: No 'call hierarchy' found, but maybe can be found in other products
`java.lang.String` | `saveFullChangeBy()` ONLY FOR SAVE CHANGE BY AS STRING Notice: Can called ONLY this property has ChangeBy value
`void` | `set(java.lang.String theval)` sets the normal value via a String.
`boolean` | `setAsAutoValue(boolean b)` Sets current is Auto value or not; effective if `isEnableAutoValue()` is true Returns true if set, and false if any exception or Auto value is disabled now Notice: if sets not, muse set other value at same time
`void` | `setCanChangeByBL(boolean bSet)` Sets can the property be changed by 'on the fly formula'
`void` | `setCanChangeByFmtt(boolean bSet)` Sets can the property be changed by 'conditional formatting'
`void` | `setCanChangeByOthers(boolean bSet)` Sets can the property be changed by 'another object'.
`void` | `setChangeByBL(java.lang.Object obj)` Deprecated.
`void` | `setChangeByBL(java.lang.Object obj, short chgByResType)` Sets properties value changing by 'on the fly formula' if canChangeByBL
`void` | `setChangeByFmtt(java.lang.Object obj)` Sets properties value changing by 'conditional formatting' if canChangeByFmtt
`void` | `setChangeByObject(java.lang.Object obj)` Deprecated.
`void` | `setChangeByObject(java.lang.Object obj, short chgByResType)` Sets properties value changing by 'another object' if canChangeByOther
`void` | `setEditFlag(int flag)` Only For Designer UI.Sets the editor status
`void` | `setEditorType(int type)` Only For Designer UI.
`void` | `setEnableAutoValue(boolean b)` Sets enable or disable Auto value
`void` | `setObject(java.lang.Object value)` Sets normal value
`void` | `setRuntimeChangeBy(java.lang.Object runtimeChgBy)` Sets runtime change by description.
`void` | `setTransient(boolean tran)` Sets attribute for 'export to RST'.
`void` | `setUnitValue(java.lang.String theval)` Sets the normal value via a String based on unit,
`java.lang.String` | `toUnitString()` Effective if `isCurrentAutoValue()` is false; returns the unit value as string, the unit value is (with priority)normal value > default value

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface jet.convert.PropInfo
`toString`

Field Detail

### TEXT_EDITOR

    public static int TEXT_EDITOR

  Editor: TEXT_EDITOR;ONLY For Designer UI

### COMBO_EDITOR

    public static int COMBO_EDITOR

  Editor: COMBO_EDITOR;ONLY For Designer UI

### COLOR_EDITOR

    public static int COLOR_EDITOR

  Editor: COLOR_EDITOR;ONLY For Designer UI

### COMMAND_EDITOR

    public static int COMMAND_EDITOR

  Editor: COMMAND_EDITOR;ONLY For Designer UI

### CHOICE_EDITOR

    public static int CHOICE_EDITOR

  Editor: CHOICE_EDITOR;ONLY For Designer UI

### DBCOL_EDITOR

    public static int DBCOL_EDITOR

  Editor: DBCOL_EDITOR;ONLY For Designer UI

### PARAMCOL_EDITOR

    public static int PARAMCOL_EDITOR

  Editor: PARAMCOL_EDITOR;ONLY For Designer UI

### QUERY_EDITOR

    public static int QUERY_EDITOR

  Editor: QUERY_EDITOR;ONLY For Designer UI

### CHART_PATTERN_LIST_EDITOR

    public static int CHART_PATTERN_LIST_EDITOR

  Editor: CHART_PATTERN_LIST_EDITOR;ONLY For Designer UI

### LINK_EDITOR

    public static int LINK_EDITOR

  Editor: LINK_EDITOR;ONLY For Designer UI

### RECORDDB_EDITOR

    public static int RECORDDB_EDITOR

  Editor: RECORDDB_EDITOR;ONLY For Designer UI

### MULSEL_EDITOR

    public static int MULSEL_EDITOR

  Editor: MULSEL_EDITOR;ONLY For Designer UI

### CHART_FILTER_EDITOR

    public static int CHART_FILTER_EDITOR

  Editor: CHART_FILTER_EDITOR; ONLY For Designer UI

### CHART_FILTER_EDITOR_NO_DATE

    public static int CHART_FILTER_EDITOR_NO_DATE

  Editor: CHART_FILTER_EDITOR_NO_DATE; ONLY For Designer UI

### CHART_ICON_STYLE

    public static int CHART_ICON_STYLE

  Editor: CHART_ICON_STYLE;ONLY For Designer UI

### DATASOURCE_EDITOR

    public static int DATASOURCE_EDITOR

  Editor: DATASOURCE_EDITOR; ONLY For Designer UI

### SECURITY_EDITOR

    public static int SECURITY_EDITOR

  Editor: SECURITY_EDITOR;ONLY For Designer UI

### DETAIL_REPORT_EDITOR

    public static int DETAIL_REPORT_EDITOR

  Editor: DETAIL_REPORT_EDITOR;ONLY For Designer UI

### CONTROL_SELECT_ITEMS

    public static int CONTROL_SELECT_ITEMS

  Editor: CONTROL_SELECT_ITEMS; ONLY For Designer UI

### EDIT_FORBIDDEN

    public static final int EDIT_FORBIDDEN

  editor status: EDIT_FORBIDDEN;, ONLY For Designer UI

  See Also:
    Constant Field Values

### EDIT_FORBIDDEN_INIT

    public static final int EDIT_FORBIDDEN_INIT

  editor status: EDIT_FORBIDDEN_INIT; ONLY For Designer UI

  See Also:
    Constant Field Values

### EDITABLE_ALLTIME

    public static final int EDITABLE_ALLTIME

  editor status: EDITABLE_ALLTIME; ONLY For Designer UI

  See Also:
    Constant Field Values

### INTERNAL

    public static final int INTERNAL

  editor status: INTERNAL; ONLY For Designer UI

  See Also:
    Constant Field Values

### CHART_TEXTSTYLE_EDITOR

    public static int CHART_TEXTSTYLE_EDITOR

  Editor: CHART_TEXTSTYLE_EDITOR;ONLY For Designer UI

### CHART_PENSTYLE_EDITOR

    public static int CHART_PENSTYLE_EDITOR

  Editor: CHART_PENSTYLE_EDITOR;ONLY For Designer UI

### CHART_FILLPATTERN_EDITOR

    public static int CHART_FILLPATTERN_EDITOR

  Editor: CHART_FILLPATTERN_EDITOR;ONLY For Designer UI

### CHART_BACKGROUND_EDITOR

    public static int CHART_BACKGROUND_EDITOR

  Editor: CHART_BACKGROUND_EDITOR;ONLY For Designer UI

Constructor Detail

### JetProperty

    public JetProperty()

### JetProperty

    public JetProperty(jet.controls.JetObject parent,
                       java.lang.String name)

Parameters:
  `parent` - owner
  `name` - name

Method Detail

### getName

    public java.lang.String getName()

  Specified by:
    `getName` in interface `jet.convert.PropInfo`
  Returns:
    name.

### isNull

    public boolean isNull()

  Is set normal value?
  Notice: This function has disabled from V8. It has not been deleted because it is an API in `PropInfo`.

  Specified by:
    `isNull` in interface `jet.convert.PropInfo`
  Returns:
    true | false.

### getPropertyChoice

    public java.util.Vector<?> getPropertyChoice()

  Only For Designer UI

  Returns:
    property choice

### getObject

    public java.lang.Object getObject()

  According to the following priority return : 'another object' > normal value > default value
  Notice1: returned 'another object' is the description of 'changed by' Notice2: Effective if `isCurrentAutoValue()` is false

  Specified by:
    `getObject` in interface `jet.util.Propertiable`
  See Also:
    `isChangeByOther()`, `isCurrentAutoValue()`

### getUnifiedObject

    public java.lang.Object getUnifiedObject()

  Effective if `isCurrentAutoValue()` is false
  According to the following priority return : ChangeBy value > normal value > default value
  Notice: returned ChangeBy value is the description of 'changed by'

  Specified by:
    `getUnifiedObject` in interface `jet.util.Propertiable`
  Since:
    V9
  See Also:
    `isChagneByFmtt()`, `isChangeByBL()`, `isChangeByOther()`, `isCurrentAutoValue()`

### getNormalObject

    public java.lang.Object getNormalObject()

  According to the following priority return : normal value > default value
  Effective if `isCurrentAutoValue()` is false

  Specified by:
    `getNormalObject` in interface `jet.util.Propertiable`
  See Also:
    `isCurrentAutoValue()`

### setObject

    public void setObject(java.lang.Object value)

  Sets normal value

  Specified by:
    `setObject` in interface `jet.util.Propertiable`

### getValue

    public java.lang.Object getValue()

  Effective if `isCurrentAutoValue()` is false

  Specified by:
    `getValue` in interface `jet.convert.PropInfo`
  Returns:
    normal value
  See Also:
    `isCurrentAutoValue()`

### set

    public void set(java.lang.String theval)

  sets the normal value via a String.

  Specified by:
    `set` in interface `jet.util.Propertiable`
  Throws:
    `jet.exception.UnsupportedFunctionException`
  See Also:
    `Object.toString()`

### setUnitValue

    public void setUnitValue(java.lang.String theval)

  Sets the normal value via a String based on unit,

  Throws:
    `jet.exception.UnsupportedFunctionException`
  See Also:
    `toUnitString()`

### setEditorType

    public void setEditorType(int type)

  Only For Designer UI. Sets the editor type.

  Parameters:
    `type` -
  See Also:
    `getEditorType()`

### getEditorType

    public int getEditorType()

  Only For Designer UI. Gets the editor type.

  See Also:
    `setEditorType(int)`

### setChangeByObject

    public final void setChangeByObject(java.lang.Object obj)

  Deprecated.

  Sets properties value changing by 'another object' if canChangeByOther, the resource type is `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource)

  Specified by:
    `setChangeByObject` in interface `jet.util.Propertiable`
  Since:
    V9
  See Also:
    `setChangeByObject(Object, short)`

### setChangeByObject

    public final void setChangeByObject(java.lang.Object obj,
                                        short chgByResType)

  Sets properties value changing by 'another object' if canChangeByOther

  Specified by:
    `setChangeByObject` in interface `jet.util.Propertiable`
  Parameters:
    `obj` - 'another object''s description: it can be formula-name, parameter-name and `null` means clear 'change by'.
    `chgByResType` - the resource type of 'another obejct', must be `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource) or `Propertiable.COMPFML_RESOURCE`(Component Level resource)
  Since:
    56369(V13)
  See Also:
    `canChangeByOther`, `setCanChangeByOthers(boolean)`, `enableAllChangeBys(boolean)`, `isChangeByOther()`, `getChangeByObject()`, `getChangeByOtherType()`

### setChangeByFmtt

    public final void setChangeByFmtt(java.lang.Object obj)

  Sets properties value changing by 'conditional formatting' if canChangeByFmtt

  Specified by:
    `setChangeByFmtt` in interface `jet.util.Propertiable`
  Parameters:
    `obj` - 'conditional formatting''s description and `null` means clear.
  Since:
    V9
  See Also:
    `canChangeByFmtt`, `setCanChangeByFmtt(boolean)`, `enableAllChangeBys(boolean)`, `isChagneByFmtt()`, `getChangeByFmtt()`

### setChangeByBL

    public final void setChangeByBL(java.lang.Object obj)

  Deprecated.

  Sets properties value changing by 'on the fly formula' if canChangeByBL, the resource type is `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource)

  Specified by:
    `setChangeByBL` in interface `jet.util.Propertiable`
  Since:
    V9
  See Also:
    `setChangeByBL(Object, short)`

### setChangeByBL

    public final void setChangeByBL(java.lang.Object obj,
                                    short chgByResType)

  Sets properties value changing by 'on the fly formula' if canChangeByBL

  Specified by:
    `setChangeByBL` in interface `jet.util.Propertiable`
  Parameters:
    `obj` - 'on the fly formula''s description and `null` means clear.
    `chgByResType` - the resource type of 'on the fly formula', must be `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource) or `Propertiable.COMPFML_RESOURCE`(Component Level resource)
  Since:
    56369(V13)
  See Also:
    `canChangeByBL`, `setCanChangeByBL(boolean)`, `enableAllChangeBys(boolean)`, `isChangeByBL()`, `getChangeByBL()`, `getChangeByBLType()`

### getChangeByObject

    public final java.lang.Object getChangeByObject()

  Effective if `isCurrentAutoValue()` is false AND `isChangeByOther()` is true. Must check `getChangeByOtherType()` before used return value

  Returns:
    the description of 'another object'. `null` means no 'another object'.
  See Also:
    `setChangeByObject(Object, short)`, `isChangeByOther()`, `isCurrentAutoValue()`, `getChangeByOtherType()`

### getChangeByOtherType

    public final short getChangeByOtherType()

  Effective if `isCurrentAutoValue()` is false AND `isChangeByOther()` is true
  Returns the resource type of 'another object': `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource) or `Propertiable.COMPFML_RESOURCE`(Component Level resource)

  Specified by:
    `getChangeByOtherType` in interface `jet.util.Propertiable`
  Since:
    56369(V13)
  See Also:
    `getChangeByObject()`, `setChangeByBL(Object, short)`, `isChangeByOther()`, `isCurrentAutoValue()`

### getChangeByFmtt

    public final java.lang.Object getChangeByFmtt()

  Effective if `isCurrentAutoValue()` is false AND `isChagneByFmtt()` is true

  Specified by:
    `getChangeByFmtt` in interface `jet.util.Propertiable`
  Returns:
    the description of 'conditional formatting'. `null` means no 'conditional formatting'.
  Since:
    V9
  See Also:
    `setChangeByFmtt(Object)`, `isChagneByFmtt()`, `isCurrentAutoValue()`

### getChangeByBL

    public final java.lang.Object getChangeByBL()

  Effective if `isCurrentAutoValue()` is false AND `isChangeByBL()` is true. Must check `getChangeByBLType()` before used return value

  Specified by:
    `getChangeByBL` in interface `jet.util.Propertiable`
  Returns:
    the description of 'on the fly formula'. `null` means no 'on the fly formula'.
  Since:
    V9
  See Also:
    `#setChangeByBL(Object,Short)`, `isChangeByBL()`, `isCurrentAutoValue()`, `getChangeByBLType()`

### getChangeByBLType

    public final short getChangeByBLType()

  Effective if `isCurrentAutoValue()` is false AND `isChangeByBL()` is true
  Returns the resource type of 'another object': `Propertiable.NORMAL_RESOURCE`(Catalog/Report Level resource) or `Propertiable.COMPFML_RESOURCE`(Component Level resource)

  Specified by:
    `getChangeByBLType` in interface `jet.util.Propertiable`
  Since:
    56369(V13)
  See Also:
    `getChangeByBL()`, `setChangeByBL(Object, short)`, `isChangeByBL()`, `isCurrentAutoValue()`

### getChangeByObjectName

    public final java.lang.String getChangeByObjectName()

  Deprecated.

  Specified by:
    `getChangeByObjectName` in interface `jet.convert.PropInfo`
  See Also:
    `getChangeByObject()`

### getChangeByFmttName

    public final java.lang.String getChangeByFmttName()

  Deprecated.

  See Also:
    `getChangeByFmtt()`

### getChangeByBLName

    public final java.lang.String getChangeByBLName()

  Deprecated.

  See Also:
    `getChangeByBL()`

### isChangeByOther

    public boolean isChangeByOther()

  Effective if `isCurrentAutoValue()` is false

  Specified by:
    `isChangeByOther` in interface `jet.convert.PropInfo`
  Specified by:
    `isChangeByOther` in interface `jet.util.Propertiable`
  Returns:
    is the properties changing by 'another object'.
  See Also:
    `setChangeByObject(Object)`, `isCurrentAutoValue()`

### isChagneByFmtt

    public boolean isChagneByFmtt()

  Effective if `isCurrentAutoValue()` is false

  Specified by:
    `isChagneByFmtt` in interface `jet.util.Propertiable`
  Returns:
    is the properties changing by 'conditional formatting'
  Since:
    V9
  See Also:
    `setChangeByFmtt(Object)`, `isCurrentAutoValue()`

### isChangeByBL

    public boolean isChangeByBL()

  Effective if `isCurrentAutoValue()` is false

  Specified by:
    `isChangeByBL` in interface `jet.util.Propertiable`
  Returns:
    is the properties changing by 'on the fly formula'
  Since:
    V9
  See Also:
    `setChangeByBL(Object)`, `isEnableAutoValue()`

### getChangeBy

    public jet.controls.JetChangeBy getChangeBy()

  Deprecated.

  Returned JetChangeBy is a unused class since V8.

  See Also:
    `getChangeByObject()`

### setCanChangeByOthers

    public void setCanChangeByOthers(boolean bSet)

  Sets can the property be changed by 'another object'.

  See Also:
    `canChangeByOther`, `canChangeByOthers()`, `enableAllChangeBys(boolean)`

### setCanChangeByFmtt

    public void setCanChangeByFmtt(boolean bSet)

  Sets can the property be changed by 'conditional formatting'

  Since:
    V9
  See Also:
    `canChangeByFmtt`, `canChangeByFmtt()`, `enableAllChangeBys(boolean)`

### setCanChangeByBL

    public void setCanChangeByBL(boolean bSet)

  Sets can the property be changed by 'on the fly formula'

  Since:
    V9
  See Also:
    `canChangeByBL`, `canChangeByBL()`, `enableAllChangeBys(boolean)`

### enableAllChangeBys

    public void enableAllChangeBys(boolean bEnable)

  Batch set can the property be changed by ChangeBy value

  Parameters:
    `bEnable` -
  Since:
    V10.1
  See Also:
    `canChangeByOther`, `canChangeByBL`, `canChangeByFmtt`, `setCanChangeByBL(boolean)`, `setCanChangeByFmtt(boolean)`, `setCanChangeByOthers(boolean)`, `canChangeByBL()`, `canChangeByFmtt()`, `canChangeByOthers()`

### canChangeByOthers

    public boolean canChangeByOthers()

  Can the property be changed by 'another object'

  Returns:
    true(can) | false (can't)
  See Also:
    `canChangeByOther`, `setCanChangeByOthers(boolean)`, `enableAllChangeBys(boolean)`

### canChangeByFmtt

    public boolean canChangeByFmtt()

  Can the property be changed by 'conditional formatting'

  Returns:
    true(can) | false (can't)
  Since:
    V9
  See Also:
    `canChangeByFmtt`, `setCanChangeByFmtt(boolean)`, `enableAllChangeBys(boolean)`

### canChangeByBL

    public boolean canChangeByBL()

  Can the property be changed by 'on the fly formula'

  Returns:
    true(can) | false (can't)
  Since:
    V9
  See Also:
    `canChangeByBL`, `setCanChangeByBL(boolean)`, `enableAllChangeBys(boolean)`

### saveFullChangeBy

    public java.lang.String saveFullChangeBy()

  ONLY FOR SAVE CHANGE BY AS STRING
  Notice: Can called ONLY this property has ChangeBy value

  Specified by:
    `saveFullChangeBy` in interface `jet.util.Propertiable`
  Returns:
    a string followed:
    RETURNED ::= CHANGEBY (VALUEDESC)?
    CHANGEBY ::= ['another object' (SUB1DELIM resource-type)?] DELIM ['conditional formatting'] DELIM ['on the fly formula' (SUB1DELIM resource-type)?]
    DELIM ::= (char)7
    SUB1DELIM ::= "~'@~"
    VALUEDESC ::= DELIM DELIMCOUNT DELIM UNITVALUE
    DELIMCOUNT ::= the count of the DELIM used in UNITVALUE
    UNITVALUE ::= encoded string value in unit*
    OTHER:
    1.(VALUEDESC) will not created if this property ONLY changedByOther
    2. Some Properties' Unit-value may contains DELIM like JetVector
  Since:
    V9
  See Also:
    `loadFullChangeBy(String)`

### loadFullChangeBy

    public void loadFullChangeBy(java.lang.String changeBy)

  ONLY FOR LOAD CHANGE BY STRING

  Specified by:
    `loadFullChangeBy` in interface `jet.util.Propertiable`
  Parameters:
    `changeBy` - it MUST FIT following regular-expression:
    INPUT ::= CHANGEBY | (CHANGEBY (VALUEDESC)?)
    CHANGEBY ::= ['another object' (SUB1DELIM resource-type)?] DELIM ['conditional formatting'] DELIM ['on the fly formula' (SUB1DELIM resource-type)?]
    DELIM ::= (char)7
    SUB1DELIM ::= "~'@~"
    VALUEDESC ::= DELIM DELIMCOUNT DELIM UNITVALUE
    DELIMCOUNT ::= the count of the DELIM used in UNITVALUE
    UNITVALUE ::= encoded string value of unit
  Since:
    V9
  See Also:
    `saveFullChangeBy()`

### propertyChanged

    public void propertyChanged()

  Force refresh the property information that managed in/by owner.
  Note to developer: No 'call hierarchy' found, but maybe can be found in other products

### toUnitString

    public java.lang.String toUnitString()

  Effective if `isCurrentAutoValue()` is false; returns the unit value as string, the unit value is (with priority)normal value > default value

  Specified by:
    `toUnitString` in interface `jet.convert.PropInfo`
  Returns:
    the string
  See Also:
    `Object.toString()`, `isCurrentAutoValue()`

### getInspValue

    public java.lang.String getInspValue(int unit,
                                         int fraction)

  Deprecated.

  Only For Designer UI.

  See Also:
    `getInspValue()`

### getInspValue

    public java.lang.String getInspValue()

  Effective if `isCurrentAutoValue()` is false. Only For Designer UI. In most cases, return string based on unit

  Specified by:
    `getInspValue` in interface `jet.convert.PropInfo`
  See Also:
    `isCurrentAutoValue()`

### setEditFlag

    public void setEditFlag(int flag)

  Only For Designer UI.Sets the editor status

  Parameters:
    `flag` - one of `EDIT_FORBIDDEN` , `EDIT_FORBIDDEN_INIT` , `EDITABLE_ALLTIME` and `INTERNAL`

### getEditFlag

    public int getEditFlag()

  Only for Designer UI. Gets the editor status

  Returns:
    one of `EDIT_FORBIDDEN` , `EDIT_FORBIDDEN_INIT` , `EDITABLE_ALLTIME` and `INTERNAL`

### getParent

    public jet.controls.JetObject getParent()

  Returns:
    the owner.

### getPropType

    public int getPropType()

  Specified by:
    `getPropType` in interface `jet.util.Propertiable`
  Returns:
    the inner type for 'export',
  See Also:
    `Propertiable`

### getMatchingSqlType

    public int[] getMatchingSqlType()

  Now, this API only for designer UI : get Matching SQL Type of this property
  Usage in UI : list all the (normal-)formula whose data-type in returned array

  See Also:
    `Db`

### setTransient

    public void setTransient(boolean tran)

  Sets attribute for 'export to RST'.

  Parameters:
    `tran` - true means not export to rst.
  See Also:
    `bTransient`, `isTransient()`

### isTransient

    public boolean isTransient()

  Gets attribute for 'export to RST'.

  Returns:
    true(not export to) | false(export to)
  See Also:
    `bTransient`, `setTransient(boolean)`

### isCurrentAutoValue

    public final boolean isCurrentAutoValue()

  Returns current is Auto value flag or not; always return false if did not enable Auto value

  Specified by:
    `isCurrentAutoValue` in interface `jet.util.Propertiable`
  See Also:
    `isEnableAutoValue()`, `setEnableAutoValue(boolean)`, `setAsAutoValue(boolean)`

### setAsAutoValue

    public final boolean setAsAutoValue(boolean b)

  Sets current is Auto value or not; effective if `isEnableAutoValue()` is true
  Returns true if set, and false if any exception or Auto value is disabled now
  Notice: if sets not, muse set other value at same time

  Specified by:
    `setAsAutoValue` in interface `jet.util.Propertiable`
  Parameters:
    `b` - true set as Auto value and false is not
  Returns:
    true if set, and false if exception or disabled.
  See Also:
    `isCurrentAutoValue()`, `isEnableAutoValue()`, `setEnableAutoValue(boolean)`

### isEnableAutoValue

    public boolean isEnableAutoValue()

  Returns is enable or disable Auto value, default return false

  See Also:
    `setAsAutoValue(boolean)`, `isCurrentAutoValue()`, `setEnableAutoValue(boolean)`

### setEnableAutoValue

    public final void setEnableAutoValue(boolean b)

  Sets enable or disable Auto value

  Parameters:
    `b` - true if enable Auto value
  See Also:
    `isCurrentAutoValue()`, `setAsAutoValue(boolean)`, `isEnableAutoValue()`

### getRuntimeChangeBy

    public java.lang.Object getRuntimeChangeBy()

  Specified by:
    `getRuntimeChangeBy` in interface `jet.util.Propertiable`

### setRuntimeChangeBy

    public void setRuntimeChangeBy(java.lang.Object runtimeChgBy)

  Sets runtime change by description.

  Specified by:
    `setRuntimeChangeBy` in interface `jet.util.Propertiable`
  Since:
    V10

### isSetRuntimeChgBy

    public boolean isSetRuntimeChgBy()

  Specified by:
    `isSetRuntimeChgBy` in interface `jet.util.Propertiable`

### isSetAnyChangeBy

    public boolean isSetAnyChangeBy()

  return true if ChangeBy Value: conditional formatting or ChangeBy Value: on the fly formula or ChangeBy Value: another object is set

  See Also:
    `isCurrentChangedBy(boolean)`, `isChangeByOther()`, `isChangeByBL()`, `isChagneByFmtt()`

### isCurrentChangedBy

    public boolean isCurrentChangedBy(boolean isIncludeRTChgBy)

  Specified by:
    `isCurrentChangedBy` in interface `jet.util.Propertiable`

### getCurrentChangedBy

    public java.lang.Object getCurrentChangedBy(boolean isIncludeRTChgBy)

  Specified by:
    `getCurrentChangedBy` in interface `jet.util.Propertiable`

### getCurrentValue

    public jet.icontrols.PropValueInfo getCurrentValue()

  Note to developer0:Now, it only can be used in Property Edit Actions and simple value parser. Note to developer1:Because no Property relative basic Logic, append here. Note to developer2:Because current Property Edit action is not for 'conditional formatting', will not return 'conditional formatting' by default,

  Returns:
    See BasicLogic#set
  See Also:
    `#getCurrentValue(boolean)}`

### getCurrentValue

    public jet.icontrols.PropValueInfo getCurrentValue(boolean isFmttContext)

  Note to developer0:Now, it only can be used in Property Edit Actions and simple value parser. Note to developer1:Because no Property relative basic Logic, append here. Note to developer2:Should check context to get value for 'conditional formatting' or not.

  Parameters:
    `isFmttContext` - is 'conditional formatting' used context? if false, will not return 'conditional formatting' settings.
  Returns:
    See BasicLogic#set

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD